=== debian/changelog ===
navit (0.5.0~svn5530+dfsg.1-1ubuntu1) saucy; urgency=low

  * Replace build-depends ttf-liberation with fonts-liberation

 -- Jackson Doak <noskcaj@ubuntu.com>  Tue, 17 Sep 2013 17:02:41 +1000

navit (0.5.0~svn5530+dfsg.1-1) unstable; urgency=low

  * New upstream snapshot:
    + gui_internal:
      - Select cyrillian keyboard for cyrillic languages
      - In town and street search dialogs, select default keyboard after
        the selected country instead of the interface language
      - Include street name in recent destination items based on house
        numbers
      - Improve house number search
      - Show POI distances to route if there is an active route
    + gui_gtk:
      - Add context menu item "Visit before a destination"
    + maptool:
      - Improvements related to borders conversion
    + navit.xml:
      - New script tag to attach scripts to objects

  * New patch
    + format-not-a-string-literal-and-no-format-arguments.patch
      named after the couple of compilation errors it fixes
  * Refresh patches
    + icons-dir                         
    + maptool-uninitialised-values.patch
    + valgrind-transform.patch

 -- Gilles Filippini <pini@debian.org>  Sun, 02 Jun 2013 17:43:02 +0200

navit (0.5.0~svn5419+dfsg.1-1) experimental; urgency=low

  * New upstream snapshot:
    + gui_internal:
      - New scripted layout setting
      - New map configuration page
      - New vehicle configuration page
      - Select point by coordinates (Closes: #534767)
      - Enhanced waypoints management
      - Display state and municipality names in town search
      - New command img for easier creation of buttons from script
      - Option to specify font size in html-like description
    + Add control structure statements to script interpreter
    + New button to bring the map view back to current position
    + New option to configure multiple maps with similar attributes with
      one tag
    + New vehicleprofile options to reduce the number of vehicle profiles
    + Improved pedestrian profile
    + New bicycle related POIs
    + Some new svg icons
    + Fix german and spanish translations
    + No more debugging output at level 0
    + New command line option '-d' to override the global debug level
      in navit.xml
    + Don't crash when setting destination with no vehicle profile selected
    + Configurable cache size
    + maptool:
      - Improvements to speed up town search
    + Many bugs and memleaks fixed (Closes: #690809)

  * Drop patches (fixed or integrated upstream):
    + mapitems.patch
    + qt-cmake.patch
    + qt-qpainter-missing-symbol.patch
    + taking-address-of-temporary-array.patch
    + keep-null-gps-vehicle.patch
    + check-empty-dest-map.patch

  * New patch
    + osd_get_attr-undefined.patch: disable undefined symbol _osd_get_attr
      in DBus binding

  * Refresh patches
    + fix-cmake.patch                   
    + icons-dir                         
    + lc_all.patch                      
    + maptool-uninitialised-values.patch
    + valgrind-transform.patch          

 -- Gilles Filippini <pini@debian.org>  Sun, 24 Mar 2013 13:14:02 +0100
