=== navit/vehicle/gpsd/CMakeLists.txt ===
module_add_library(vehicle_gpsd vehicle_gpsd.c)
